6 # Build LLVM the "Apple way".
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
28 # The fifth parameter is the place where the compiler will be copied once it's
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
45 # A yes/no parameter that controls whether to cross-build for an ARM host.
48 # A yes/no parameter that controls whether to cross-build for the iOS simulator
51 # The version number of the submission, e.g. 1007.
52 LLVM_SUBMIT_VERSION="${11}"
54 # The subversion number of the submission, e.g. 03.
55 LLVM_SUBMIT_SUBVERSION="${12}"
57 # The current working directory is where the build will happen. It may already
58 # contain a partial result of an interrupted build, in which case this script
59 # will continue where it left off.
62 DARWIN_VERS=`uname -r | sed 's/\..*//'`
63 echo DARWIN_VERS = $DARWIN_VERS
65 ################################################################################
68 # Create the source tree we'll actually use to build, deleting
69 # tcl since it doesn't actually build properly in a cross environment
70 # and we don't really need it.
72 rm -rf $SRC_DIR || exit 1
73 mkdir $SRC_DIR || exit 1
74 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
75 # We can't use the top-level Makefile as-is. Remove the soft link:
76 rm $SRC_DIR/Makefile || exit 1
77 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
78 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
80 # Build the LLVM tree universal.
81 mkdir -p $DIR/obj-llvm || exit 1
82 cd $DIR/obj-llvm || exit 1
84 if [ "$ARM_HOSTED_BUILD" = yes ]; then
85 # The cross-tools' build process expects to find an existing cross toolchain
86 # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
87 rm -rf $DIR/bin || exit 1
88 mkdir $DIR/bin || exit 1
89 for prog in ar nm ranlib strip lipo ld as ; do
90 P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
91 T=`xcrun -sdk $SDKROOT -find ${prog}`
92 echo '#!/bin/sh' > $P || exit 1
93 echo 'exec '$T' "$@"' >> $P || exit 1
94 chmod a+x $P || exit 1
96 # Set up the links for clang.
97 for prog in clang clang++ ; do
98 P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
99 T=`xcrun -sdk $SDKROOT -find ${prog}`
100 echo '#!/bin/sh' > $P || exit 1
101 echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
102 chmod a+x $P || exit 1
108 if [ "$ARM_HOSTED_BUILD" = yes ]; then
109 configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
110 --target=arm-apple-darwin10 --build=i686-apple-darwin10"
111 elif [ "$IOS_SIM_BUILD" = yes ]; then
112 # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
113 configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
114 --build=i686-apple-darwin10"
116 configure_opts="--enable-targets=arm,x86"
119 if [ "$ARM_HOSTED_BUILD" != yes ]; then
120 if [ $SDKROOT ]; then
121 CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT"
123 for host in $HOSTS; do :; done
124 CPPFLAGS="$CPPFLAGS -arch $host"
127 if [ \! -f Makefile.config ]; then
128 $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
129 --enable-assertions=$LLVM_ASSERTIONS \
130 --enable-optimized=$LLVM_OPTIMIZED \
132 CPPFLAGS="$CPPFLAGS" \
136 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
138 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
139 LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
140 RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
141 LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
144 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
145 LLVM_VERSION="$LLVM_SUBMIT_VERSION"
147 LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
150 # Figure out how many make processes to run.
151 SYSCTL=`sysctl -n hw.activecpu`
152 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
153 # Builders can default to 2, since even if they are single processor,
154 # nothing else is running on the machine.
155 if [ -z "$SYSCTL" ]; then
158 JOBS_FLAG="-j $SYSCTL"
160 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
161 UNIVERSAL_SDK_PATH=$SDKROOT \
166 LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
167 LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
168 CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
171 if [ $? != 0 ] ; then
172 echo "error: LLVM 'make' failed!"
176 ################################################################################
177 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
178 # $DEST_DIR, with occasional 'lipo' commands.
180 cd $DEST_DIR || exit 1
182 # Clean out DEST_DIR in case -noclean was passed to buildit.
185 cd $DIR/obj-llvm || exit 1
187 # Install the tree into the destination directory.
188 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
192 LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
193 LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
194 OPTIMIZE_OPTION='-O3' VERBOSE=1 install
196 if ! test $? == 0 ; then
197 echo "error: LLVM 'make install' failed!"
202 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
203 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
206 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
207 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
208 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
210 # Find the right version of strip to use.
212 if [ -n "$SDKROOT" ]; then
213 STRIP=`xcrun -sdk $SDKROOT -find strip`
216 if [ "x$LLVM_DEBUG" != "x1" ]; then
217 # Strip local symbols from llvm libraries.
219 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
221 $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
222 for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
228 cd $DEST_DIR$DEST_ROOT
229 rm -f bin/.dir etc/llvm/.dir lib/.dir
231 # The Hello dylib is an example of how to build a pass.
232 # The BugpointPasses module is only used to test bugpoint.
233 # These unversioned dylibs cause verification failures, so do not install them.
234 # (The wildcards are used to match a "lib" prefix if it is present.)
235 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
236 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
239 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
242 ################################################################################
243 # Create SYM_DIR with information required for debugging.
245 # Figure out how many make processes to run.
246 SYSCTL=`sysctl -n hw.activecpu`
248 # hw.activecpu only available in 10.2.6 and later
249 if [ -z "$SYSCTL" ]; then
250 SYSCTL=`sysctl -n hw.ncpu`
253 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
254 # can default to 2, since even if they are single processor, nothing else is
255 # running on the machine.
256 if [ -z "$SYSCTL" ]; then
260 cd $SYM_DIR || exit 1
262 # Clean out SYM_DIR in case -noclean was passed to buildit.
265 # Generate .dSYM files
266 find $DEST_DIR -perm -0111 -type f \
267 ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
268 -print | xargs -n 1 -P ${SYSCTL} dsymutil
270 # Save .dSYM files and .a archives
271 cd $DEST_DIR || exit 1
272 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
273 | cpio -pdml $SYM_DIR || exit 1
276 mkdir $SYM_DIR/src || exit 1
278 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
279 | cpio -pdml $SYM_DIR/src || exit 1
281 ################################################################################
282 # Remove libLTO.dylib and lto.h. Those are installed by clang.
284 cd $DEST_DIR$DEST_ROOT
285 rm -f lib/libLTO.dylib
286 rm -f lib/libLTO.a lib/libLTO.la
287 find $DEST_DIR$DEST_ROOT -name lto.h -delete
289 ################################################################################
290 # Remove debugging information from DEST_DIR.
294 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
295 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
297 # Strip debugging information from files
299 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
301 find $DEST_DIR -perm -0111 -type f \
302 ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
303 -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
305 chgrp -h -R wheel $DEST_DIR
306 chgrp -R wheel $DEST_DIR
308 ################################################################################
309 # Remove the docs directory
311 rm -rf $DEST_DIR$DEST_ROOT/docs
313 ################################################################################